local goodFlask = 250
local goodFood = 100

local scantip = CreateFrame("GameTooltip", "BuffTooltip", nil, "GameTooltipTemplate")
scantip:SetOwner(UIParent, "ANCHOR_NONE")

local function scanTooltip(unitID, index, lookingFor)
    scantip:SetUnitBuff(unitID, index)
	local text = BuffTooltipTextLeft2:GetText()
	local strstart = select(1, string.find(text, lookingFor))

	if (strstart ~= nil) then
		return true
	else
		return false
	end
end

SlashCmdList['BUFFCHECK'] = function(newtime)
	local playerBuffs = {}
	local whispers = {}
	local raidsay = {}
	local playerNumber = GetNumGroupMembers()
	for i = 1, playerNumber do
		local playerName = select(1, GetRaidRosterInfo(i))
		
		local entry = {
			['name'] = playerName,
			['food'] = false,
			['flask'] = false,
			['goodFood'] = false,
			['goodFlask'] = false
		}
		
		playerBuffs[i] = entry

		if (IsInRaid()) then
			for u = 1, 40 do
				local buffName = select(1, UnitBuff(playerName, u));
				
				if (buffName ~= nil) then
				
					local isFed = select(1, string.find(buffName, "Well Fed"))
					local isFlasked = select(1, string.find(buffName, "Flask of"))

					if (isFed ~= nil) then
						local foodLevel = scanTooltip(playerName, u, goodFood)
						
						if (foodLevel) then
							playerBuffs[i]['food'] = true
							playerBuffs[i]['goodFood'] = true
						else
							playerBuffs[i]['food'] = true
						end
					end
					
					if (isFlasked ~= nil) then
						local flaskLevel = scanTooltip(playerName, u, goodFlask)
						if (flaskLevel) then
							playerBuffs[i]['flask'] = true
							playerBuffs[i]['goodFlask'] = true
						else
							playerBuffs[i]['flask'] = true
						end
					end
				
				end
			end
		else
			print("Can only check buffs in a raid")
		end
	end
	
	-- Loop through the final results and build a printable string
	for i = 1, #playerBuffs do
		local printString = nil;
		local whisperString = nil;
		local player = playerBuffs[i]
		local playerName = playerBuffs[i]['name']
		
		
		if (not player['goodFlask']) then
			printString = playerName..": ";
			whisperString = "You still need";
			if (player['flask']) then
				printString = printString.."Bad Flask";
				whisperString = whisperString.." a better Flask";
			else
				printString = printString.."No Flask";
				whisperString = whisperString.." a Flask";
			end
		end
		
		if (not player['goodFood']) then
			if (player['food']) then
				printString = printString..", bad Food.";
				whisperString = whisperString.." and better Food.";
			else
				printString = printString..", no Food.";
				whisperString = whisperString.." and Food.";
			end
		elseif (printString ~= nil) then
			printString = printString..".";
			whisperString = whisperString..".";
		end
		local whisper = {}--{playerName, whisperString}
		whisper[0] = playerName
		whisper[1] = whisperString


		-- we're storing those so we can loop through them and send all whispers at once, then all raidsays at once, instead of alternating (which is hard to read)
		whispers[i] = whisper
		raidsay[i] = printString

	end
	
	for i = 1, #whispers do
		SendChatMessage(whispers[i][1], "WHISPER", nil, whispers[i][0])
	end
	for i = 1, #raidsay do
		SendChatMessage(raidsay[i], "RAID")
	end
	
	whispers = {}
	raidsay = {}

end

SLASH_BUFFCHECK1 = "/buffcheck"
SLASH_BUFFCHECK1 = "/rbc"